diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index 9b7cac3e1..130968d24 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -20,11 +20,13 @@ import javax.swing.JFrame;
 
 import com.mojang.logging.CategorizedLogger;
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.util.debug.GLFWLoggerCallback;
 import net.minecraft.client.util.debug.OpenGLLoggerCallback;
 import net.minecraft.core.BuildChannel;
 import net.minecraft.core.Global;
 import net.minecraft.core.Version;
+import net.minecraft.core.enums.EnumOS;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.PointerBuffer;
@@ -104,15 +106,39 @@ public class GameWindowGLFW implements GameWindow {
         glfwWindowHint(GLFW_VISIBLE, 0);
         glfwWindowHint(GLFW_AUTO_ICONIFY, 1);
         glfwWindowHint(GLFW_DECORATED, 1);
-
-        // Create window
-        this.window = glfwCreateWindow(width, height, "Better than Adventure! " + Global.VERSION, 0, 0);
-        if (this.window == NULL) {
-            try (MemoryStack stack = MemoryStack.stackPush()) {
-                PointerBuffer b = stack.callocPointer(1);
-                glfwGetError(b);
-                throw new NullPointerException(b.getStringASCII());
+        glfwWindowHint(GLFW_OPENGL_FORWARD_COMPAT, GLFW_TRUE);
+
+        // Iterating through GL versions because theres not way to just request "Highest but atleast X.X" and if forward compat is set on then not request a version causes a crash
+        for (int i = 0; i < OpenGLHelper.versionPairs.length; i += 2) {
+            glfwWindowHint(GLFW_CONTEXT_VERSION_MAJOR, OpenGLHelper.versionPairs[i]);
+            glfwWindowHint(GLFW_CONTEXT_VERSION_MINOR, OpenGLHelper.versionPairs[i + 1]);
+
+            // Create window
+            this.window = glfwCreateWindow(width, height, "Better than Adventure! " + Global.VERSION, 0, 0);
+            if (this.window == NULL) {
+                if (i == (OpenGLHelper.versionPairs.length - 2)) {
+                    try (MemoryStack stack = MemoryStack.stackPush()) {
+                        PointerBuffer b = stack.callocPointer(1);
+                        glfwGetError(b);
+                        throw new NullPointerException("Failed to create window: " + b.getStringASCII());
+                    }
+                }
+                continue;
             }
+            break;
+        }
+        // OpenGL setup
+        glfwMakeContextCurrent(this.window);
+        GLCapabilities capabilities = GL.createCapabilities(true);
+        OpenGLHelper.testCapabilities(capabilities);
+
+        if (capabilities.OpenGL43 && debug) {
+            GL11.glEnable(GL43.GL_DEBUG_OUTPUT);
+            this.glDebugMessageCallback = new OpenGLLoggerCallback();
+            GL43.glDebugMessageCallback(this.glDebugMessageCallback, NULL);
+            LOGGER.info("GL4.3 supported, enabling GL Error logging");
+        } else {
+            LOGGER.info("GL4.3 not supported, cannot enable GL Error logging");
         }
 
         // Set widths and heights
@@ -154,39 +180,29 @@ public class GameWindowGLFW implements GameWindow {
         });
 
         // Setup Icon
-        iconLabel:
-        {
-            int[] resolutions = new int[]{16, 32, 64, 128, 256};
-            GLFWImage.Buffer gb = GLFWImage.create(resolutions.length);
-            for (int res : resolutions) {
-                ByteBuffer icon = getImageBuffer("/icon/" + res + ".png");
-                if (icon == null) {
-                    LOGGER.error("Icon at resolution '{}' is null! Skipping icons!", res);
-                    gb.close();
-                    break iconLabel;
+        if (Minecraft.getOs() != EnumOS.macos) { // MacOs doesn't support icons
+            iconLabel:
+            {
+                int[] resolutions = new int[]{16, 32, 64, 128, 256};
+                GLFWImage.Buffer gb = GLFWImage.create(resolutions.length);
+                for (int res : resolutions) {
+                    ByteBuffer icon = getImageBuffer("/icon/" + res + ".png");
+                    if (icon == null) {
+                        LOGGER.error("Icon at resolution '{}' is null! Skipping icons!", res);
+                        gb.close();
+                        break iconLabel;
+                    }
+                    GLFWImage iconGI = GLFWImage.create().set(res, res, icon);
+                    gb.put(iconGI);
+                    this.stbiIconImages.add(icon);
                 }
-                GLFWImage iconGI = GLFWImage.create().set(res, res, icon);
-                gb.put(iconGI);
-                this.stbiIconImages.add(icon);
+                glfwSetWindowIcon(this.window, gb.flip());
             }
-            glfwSetWindowIcon(this.window, gb.flip());
         }
 
         // Show window
         glfwShowWindow(this.window);
 
-        // OpenGL setup
-        glfwMakeContextCurrent(this.window);
-        GLCapabilities capabilities = GL.createCapabilities();
-        if (capabilities.OpenGL43 && debug) {
-            GL11.glEnable(GL43.GL_DEBUG_OUTPUT);
-            this.glDebugMessageCallback = new OpenGLLoggerCallback();
-            GL43.glDebugMessageCallback(this.glDebugMessageCallback, NULL);
-            LOGGER.info("GL4.3 supported, enabling GL Error logging");
-        } else {
-            LOGGER.info("GL4.3 not supported, cannot enable GL Error logging");
-        }
-
         // Input setup
         Display.setWindow(this);
 
diff --git a/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java b/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
index 8d1c17267..61584af1b 100644
--- a/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
+++ b/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
@@ -1,218 +1,218 @@
 package net.minecraft.client.util.debug;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.util.debug.Debug;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.Display;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.util.debug.Debug.Profiler;
 import net.minecraft.core.util.helper.MathHelper;
 
 public class DebugRender {
-	
-	private static Profiler selectedProfiler = Debug.baseProfiler;
-	private static final long[] frametimes = new long[512];
-	private static final long[] baseframetimes = new long[512];
-	private static int pos = 0;
-	private static int scale = 200000;
-	private static int selection = 0;
-	
-	public static void onDebugMenuOpened() {
-	}
-	
-	public static boolean keyPressed(int key) {
-		if(key == Keyboard.KEY_LEFT) {
-			if(selectedProfiler.parent != null) {
-				Profiler prev = selectedProfiler;
-				set(selectedProfiler.parent);
-				selection = selectedProfiler.allProfilers.indexOf(prev);
-			}
-			return true;
-		}
-		if(key == Keyboard.KEY_UP) {
-			if(selection == 0) {
-				selection = selectedProfiler.allProfilers.size() - 1;
-			}else {
-				selection--;
-			}
-			return true;
-		}
-		if(key == Keyboard.KEY_DOWN) {
-			if(selection >= selectedProfiler.allProfilers.size() - 1) {
-				selection = 0;
-			}else {
-				selection++;
-			}
-			return true;
-		}
-		if(key == Keyboard.KEY_RIGHT) {
-			if(selection >= 0 && selection < selectedProfiler.allProfilers.size()) {
-				set(selectedProfiler.allProfilers.get(selection));
-				selection = 0;
-			}
-			return true;
-		}
-		
-		return false;
-	}
-	
-	private static void set(Profiler profiler) {
-		selectedProfiler = profiler;
-		resetFrametimes();
-	}
-	
-	public static void render(FontRenderer sr) {
-		frametimes[pos] = selectedProfiler.time;
-		baseframetimes[pos] = Debug.baseProfiler.time;
-		pos++;
-		if(pos >= frametimes.length) pos = 0;
-		
-		int w = Display.getWidth();
-		int h = Display.getHeight();
-		
-		glMatrixMode(GL_PROJECTION);
-		glLoadIdentity();
-		glOrtho(0, w, h, 0, -1, 1);
-		
-		glMatrixMode(GL_MODELVIEW);
-		glLoadIdentity();
-		
-		glDisable(GL_DEPTH_TEST);
-		glEnable(GL_ALPHA_TEST);
-		glDisable(GL_TEXTURE_2D);
-		glDisable(GL_CULL_FACE);
-		glDisable(GL_LIGHTING);
-		glEnable(GL_BLEND);
-		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-		
-		Tessellator t = Tessellator.instance;
-		
-		int x = w - frametimes.length;
-		int y = h;
-		
-		if(selectedProfiler != Debug.baseProfiler) {
-			if(w > frametimes.length + baseframetimes.length) {
-				drawFrameTimes(t, x, y, baseframetimes);
-			}
-			drawFrameTimes(t, 0, y, frametimes);
-		}else {
-			drawFrameTimes(t, 0, y, baseframetimes);
-		}
-
-		glDisable(GL_BLEND);
-		glEnable(GL_TEXTURE_2D);
-		glColor4d(1.0, 1.0, 1.0, 1.0);
-		
-		int lineHeight = 8;
-		int x1 = frametimes.length;
-		int y1 = h - (selectedProfiler.allProfilers.size() + 1) * lineHeight * 2;
+
+    private static Profiler selectedProfiler = Debug.baseProfiler;
+    private static final long[] frametimes = new long[512];
+    private static final long[] baseframetimes = new long[512];
+    private static int pos = 0;
+    private static int scale = 200000;
+    private static int selection = 0;
+
+    public static void onDebugMenuOpened() {
+    }
+
+    public static boolean keyPressed(int key) {
+        if (key == Keyboard.KEY_LEFT) {
+            if (selectedProfiler.parent != null) {
+                Profiler prev = selectedProfiler;
+                set(selectedProfiler.parent);
+                selection = selectedProfiler.allProfilers.indexOf(prev);
+            }
+            return true;
+        }
+        if (key == Keyboard.KEY_UP) {
+            if (selection == 0) {
+                selection = selectedProfiler.allProfilers.size() - 1;
+            } else {
+                selection--;
+            }
+            return true;
+        }
+        if (key == Keyboard.KEY_DOWN) {
+            if (selection >= selectedProfiler.allProfilers.size() - 1) {
+                selection = 0;
+            } else {
+                selection++;
+            }
+            return true;
+        }
+        if (key == Keyboard.KEY_RIGHT) {
+            if (selection >= 0 && selection < selectedProfiler.allProfilers.size()) {
+                set(selectedProfiler.allProfilers.get(selection));
+                selection = 0;
+            }
+            return true;
+        }
+
+        return false;
+    }
+
+    private static void set(Profiler profiler) {
+        selectedProfiler = profiler;
+        resetFrametimes();
+    }
+
+    public static void render(FontRenderer sr) {
+        frametimes[pos] = selectedProfiler.time;
+        baseframetimes[pos] = Debug.baseProfiler.time;
+        pos++;
+        if (pos >= frametimes.length) pos = 0;
+
+        int w = Display.getWidth();
+        int h = Display.getHeight();
+
+        GLRenderer.pushFrame();
+        GLRenderer.projectionM4f().identity().ortho(0, w, h, 0, -1, 1);
+        GLRenderer.viewM4f().identity();
+        GLRenderer.modelM4f().identity();
+
+//		glEnable(GL_ALPHA_TEST);
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.disableState(State.CULL_FACE);
+//		glDisable(GL_LIGHTING);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+
+        TessellatorGeneral t = GLRenderer.getTessellator();
+
+        int x = w - frametimes.length;
+        int y = h;
+
+        if (selectedProfiler != Debug.baseProfiler) {
+            if (w > frametimes.length + baseframetimes.length) {
+                drawFrameTimes(t, x, y, baseframetimes);
+            }
+            drawFrameTimes(t, 0, y, frametimes);
+        } else {
+            drawFrameTimes(t, 0, y, baseframetimes);
+        }
+
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.setShader(Shaders.INTERFACE);
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+
+        int lineHeight = 8;
+        int x1 = frametimes.length;
+        int y1 = h - (selectedProfiler.allProfilers.size() + 1) * lineHeight * 2;
 //		int y1 = h - 33333333 / scale;
-		glTranslated(x1, y1, 0);
-		x1 = 0;
-		y1 = 0;
-		glScaled(2.0, 2.0, 2.0);
-		
-		int fps = Debug.getFps();
-		if(fps >= 0) {
-			sr.render(t, "fps: " + fps, x1, y1 - 2 * lineHeight).call();
-		}
-		sr.render(t, "avg: " + (getAvgTime(frametimes) / 1000.0) + " ms", x1, y1 - lineHeight).call();
-		sr.render(t, selectedProfiler.name + ": ", x1, y1).call();
-		for(int i=0; i < selectedProfiler.allProfilers.size(); i++) {
-			Profiler profiler = selectedProfiler.allProfilers.get(i);
-
-			int color = 0xFFFFFFFF;
-			if(i == selection) {
-				color = 0xFF00FFFF;
-			}
-			sr.render(t, i + ": " + profiler.name, x1, y1 + (i + 1) * lineHeight).setColor(color).call();
-		}
-		glEnable(GL_ALPHA_TEST);
-	}
-	
-	private static long getAvgTime(long[] frametimes) {
-		long avg = 0;
-		int count = 0;
-		for(int i=0; i < frametimes.length; i++) {
-			long time = frametimes[i];
-			if(time > 0) {
-				avg += frametimes[i] / 1000;
-				count++;
-			}
-		}
-		if(count == 0) {
-			return 1;
-		}
-		avg /= count;
-		return avg;
-	}
-	
-	private static void drawFrameTimes(Tessellator tessellator, int x, int y, long[] frametimes) {
-		int h1 = 16666666 / scale;
-		int h2 = 33333333 / scale;
-		
-		tessellator.startDrawingQuads();
-		tessellator.setColorRGBA(0, 0, 0, 127);
-		drawRectangle(tessellator, x, y - h2, frametimes.length, h2);
-		drawRectangle(tessellator, x, y - h1, frametimes.length, h1);
-		tessellator.setColorOpaque_I(0xFFFFFF);
-
-
-		
-		for(int i=0; i < frametimes.length; i++) {
-			float brightness = ((i - pos) & (frametimes.length - 1)) / (float) frametimes.length;
-			brightness = brightness * brightness;
-			int b = MathHelper.clamp((int) (brightness * 255.0f), 0, 255);
-			tessellator.setColorOpaque_I(b << 16 | b << 8 | b);
-			
-			int time = (int) (frametimes[i] / scale);
-			drawRectangle(tessellator, x + i, y - time, 1, time);
-		}
-
-		final int tickLagHeight = (int) ((1000/20d * 1000 * 1000)/(double) scale);
-
-		tessellator.setColorOpaque_I(0xFF0000);
-		drawRectangle(tessellator, x, y - tickLagHeight, frametimes.length, 1);
-
-		Minecraft mc = Minecraft.getMinecraft();
-		if (mc.gameSettings.customFpsLimit.value > 0 || mc.gameSettings.enableVsync.value){
-			tessellator.setColorOpaque_I(0x00FF00);
-			int fps;
-			if (mc.gameSettings.enableVsync.value){
-				fps = mc.gameWindow.getFrequency(); // Cap fps when minimized
-			} else {
-				fps = mc.gameSettings.customFpsLimit.value;
-			}
-
-			int frameLagHeight = (int) ((1000d/fps * 1000 * 1000)/scale);
-			drawRectangle(tessellator, x, y - frameLagHeight, frametimes.length, 1);
-		}
-
-		tessellator.draw();
-	}
-	
-	private static void drawRectangle(Tessellator tessellator, int x, int y, int w, int h) {
-		tessellator.addVertex(x, y, 0);
-		tessellator.addVertex(x+w, y, 0);
-		tessellator.addVertex(x+w, y+h, 0);
-		tessellator.addVertex(x, y+h, 0);
-	}
-	
-	private static void resetFrametimes() {
-		for(int i=0; i < frametimes.length; i++) {
-			frametimes[i] = 0L;
-		}
+        GLRenderer.modelM4f().translate(x1, y1, 0);
+        x1 = 0;
+        y1 = 0;
+        GLRenderer.modelM4f().scale(2.0f, 2.0f, 2.0f);
+
+        int fps = Debug.getFps();
+        if (fps >= 0) {
+            sr.render("fps: " + fps, x1, y1 - 2 * lineHeight).call();
+        }
+        sr.render("avg: " + (getAvgTime(frametimes) / 1000.0) + " ms", x1, y1 - lineHeight).call();
+        sr.render(selectedProfiler.name + ": ", x1, y1).call();
+        for (int i = 0; i < selectedProfiler.allProfilers.size(); i++) {
+            Profiler profiler = selectedProfiler.allProfilers.get(i);
+
+            int color = 0xFFFFFFFF;
+            if (i == selection) {
+                color = 0xFF00FFFF;
+            }
+            sr.render(i + ": " + profiler.name, x1, y1 + (i + 1) * lineHeight).setColor(color).call();
+        }
+//		glEnable(GL_ALPHA_TEST);
+        GLRenderer.popFrame();
+    }
+
+    private static long getAvgTime(long[] frametimes) {
+        long avg = 0;
+        int count = 0;
+        for (int i = 0; i < frametimes.length; i++) {
+            long time = frametimes[i];
+            if (time > 0) {
+                avg += frametimes[i] / 1000;
+                count++;
+            }
+        }
+        if (count == 0) {
+            return 1;
+        }
+        avg /= count;
+        return avg;
+    }
+
+    private static void drawFrameTimes(TessellatorGeneral tessellator, int x, int y, long[] frametimes) {
+        int h1 = 16666666 / scale;
+        int h2 = 33333333 / scale;
+
+        tessellator.startDrawingQuads();
+        tessellator.setColor4i(0, 0, 0, 127);
+        drawRectangle(tessellator, x, y - h2, frametimes.length, h2);
+        drawRectangle(tessellator, x, y - h1, frametimes.length, h1);
+        tessellator.setColorOpaque1i(0xFFFFFF);
+
+
+        for (int i = 0; i < frametimes.length; i++) {
+            float brightness = ((i - pos) & (frametimes.length - 1)) / (float) frametimes.length;
+            brightness = brightness * brightness;
+            int b = MathHelper.clamp((int) (brightness * 255.0f), 0, 255);
+            tessellator.setColorOpaque1i(b << 16 | b << 8 | b);
+
+            int time = (int) (frametimes[i] / scale);
+            drawRectangle(tessellator, x + i, y - time, 1, time);
+        }
+
+        final int tickLagHeight = (int) ((1000 / 20d * 1000 * 1000) / (double) scale);
+
+        tessellator.setColorOpaque1i(0xFF0000);
+        drawRectangle(tessellator, x, y - tickLagHeight, frametimes.length, 1);
+
+        Minecraft mc = Minecraft.getMinecraft();
+        if (mc.gameSettings.customFpsLimit.value > 0 || mc.gameSettings.enableVsync.value) {
+            tessellator.setColorOpaque1i(0x00FF00);
+            int fps;
+            if (mc.gameSettings.enableVsync.value) {
+                fps = mc.gameWindow.getFrequency(); // Cap fps when minimized
+            } else {
+                fps = mc.gameSettings.customFpsLimit.value;
+            }
+
+            int frameLagHeight = (int) ((1000d / fps * 1000 * 1000) / scale);
+            drawRectangle(tessellator, x, y - frameLagHeight, frametimes.length, 1);
+        }
+
+        tessellator.draw();
+    }
+
+    private static void drawRectangle(TessellatorGeneral tessellator, int x, int y, int w, int h) {
+        tessellator.addVertex(x, y, 0);
+        tessellator.addVertex(x + w, y, 0);
+        tessellator.addVertex(x + w, y + h, 0);
+        tessellator.addVertex(x, y + h, 0);
+    }
+
+    private static void resetFrametimes() {
+        for (int i = 0; i < frametimes.length; i++) {
+            frametimes[i] = 0L;
+        }
 //		for(int i=0; i < baseframetimes.length; i++) {
 //			baseframetimes[i] = 0L;
 //		}
-	}
-	
-	public static void dontRender() {
-		
-	}
+    }
+
+    public static void dontRender() {
+
+    }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
index 063c8600f..85b158547 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
@@ -1,14 +1,13 @@
 package net.minecraft.client.util.helper;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import java.util.ArrayList;
-import java.util.HashSet;
 import java.util.List;
-import java.util.Set;
 
 import it.unimi.dsi.fastutil.ints.IntArraySet;
 import it.unimi.dsi.fastutil.ints.IntSet;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import org.lwjgl.input.Keyboard;
 
 import net.minecraft.client.Minecraft;
@@ -28,7 +27,7 @@ public class ItemDragHandler extends Gui {
 	private int renderOffsetX;
 	private int renderOffsetY;
 	
-	private IntSet cancelRelease = new IntArraySet();
+	private final IntSet cancelRelease = new IntArraySet();
 	
 	///////////////////////
 	
@@ -54,36 +53,36 @@ public class ItemDragHandler extends Gui {
 	}
 	
 	public void drawScreen(int mouseX, int mouseY, float partialTicks) {
-		renderOffsetX = 0;
-		renderOffsetY = 0;
+        this.renderOffsetX = 0;
+        this.renderOffsetY = 0;
 		
 		if(isDragging()) {
 			Slot slot = getSlotAt(mouseX, mouseY);
 			
 			onDragOverSlot(slot);
 			
-			if(draggedSlots.size() > 1) {
-				renderItemStack = draggingItemStack.copy();
-				renderItemStack.stackSize = 1;
+			if(this.draggedSlots.size() > 1) {
+                this.renderItemStack = this.draggingItemStack.copy();
+                this.renderItemStack.stackSize = 1;
 
-				boolean isCreativeDragging = draggingButton == 2 && !mc.thePlayer.getGamemode().consumeBlocks();
+				boolean isCreativeDragging = this.draggingButton == 2 && !this.mc.thePlayer.getGamemode().consumeBlocks();
 				
 				if(isCreativeDragging) {
-					renderItemStackCount = draggingItemStack.getMaxStackSize();
-				}else if(draggingButton == 1) {
-					renderItemStackCount = 1;
+                    this.renderItemStackCount = this.draggingItemStack.getMaxStackSize();
+				}else if(this.draggingButton == 1) {
+                    this.renderItemStackCount = 1;
 				}else {
-					renderItemStackCount = draggingItemStack.stackSize / draggedSlots.size();
+                    this.renderItemStackCount = this.draggingItemStack.stackSize / this.draggedSlots.size();
 				}
 				
-				for(int i=0; i < draggedSlots.size(); i++) {
-					drawSlotOverlayWhileDragging(draggedSlots.get(i));
+				for(int i = 0; i < this.draggedSlots.size(); i++) {
+					drawSlotOverlayWhileDragging(this.draggedSlots.get(i));
 				}
 				
 				if(isCreativeDragging) {
-					renderItemStack.stackSize = 1;
+                    this.renderItemStack.stackSize = 1;
 				}else {
-					renderItemStack.stackSize = draggingItemStack.stackSize - (draggedSlots.size() * renderItemStackCount);	
+                    this.renderItemStack.stackSize = this.draggingItemStack.stackSize - (this.draggedSlots.size() * this.renderItemStackCount);
 				}
 			}
 		}
@@ -92,15 +91,15 @@ public class ItemDragHandler extends Gui {
 	private void onDragOverSlot(Slot slot) {
 		if(slot == null) return;
 		
-		boolean isCreativeDragging = draggingButton == 2 && !mc.thePlayer.getGamemode().consumeBlocks();
-		if(draggedSlots.size() >= draggingItemStack.stackSize && !isCreativeDragging) {
+		boolean isCreativeDragging = this.draggingButton == 2 && !this.mc.thePlayer.getGamemode().consumeBlocks();
+		if(this.draggedSlots.size() >= this.draggingItemStack.stackSize && !isCreativeDragging) {
 			return;
 		}
 		
-		if(slot.mayPlace(draggingItemStack) && slot.enableDragAndPickup()) {
-			if(slot.getItemStack() == null || slot.getItemStack().canStackWith(draggingItemStack)) {
-				if(!draggedSlots.contains(slot)) {
-					draggedSlots.add(slot);
+		if(slot.mayPlace(this.draggingItemStack) && slot.enableDragAndPickup()) {
+			if(slot.getItemStack() == null || slot.getItemStack().canStackWith(this.draggingItemStack)) {
+				if(!this.draggedSlots.contains(slot)) {
+                    this.draggedSlots.add(slot);
 				}
 			}
 		}
@@ -108,24 +107,23 @@ public class ItemDragHandler extends Gui {
 	
 	private void drawSlotOverlayWhileDragging(Slot slot) {
 		if(slot == null) throw new NullPointerException("Slot is null");
-		if(draggingItemStack == null) throw new NullPointerException("Stack is null!");
+		if(this.draggingItemStack == null) throw new NullPointerException("Stack is null!");
 
 		ItemStack stack = slot.getItemStack();
-		
-		glDisable(GL_TEXTURE_2D);
-		glEnable(GL_BLEND);
-		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-		
-		drawRectWidthHeight(renderOffsetX + slot.x, renderOffsetY + slot.y, 16, 16, 0x80ffffff);
-		
-		glDisable(GL_BLEND);
-		glEnable(GL_TEXTURE_2D);
-		
-		renderItemStack.stackSize = renderItemStackCount;
+
+		GLRenderer.pushFrame();
+		GLRenderer.enableState(State.BLEND);
+		GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+
+		drawRectWidthHeight(this.renderOffsetX + slot.x, this.renderOffsetY + slot.y, 16, 16, 0x80ffffff);
+
+		GLRenderer.popFrame();
+
+        this.renderItemStack.stackSize = this.renderItemStackCount;
 		if(stack != null) {
-			renderItemStack.stackSize = Math.min(renderItemStack.getMaxStackSize(), renderItemStack.stackSize + stack.stackSize);
+            this.renderItemStack.stackSize = Math.min(this.renderItemStack.getMaxStackSize(), this.renderItemStack.stackSize + stack.stackSize);
 		}
-		itemElement.render(renderItemStack, slot.x, slot.y);
+        this.itemElement.render(this.renderItemStack, slot.x, slot.y);
 	}
 	
 	public void mouseEvent(final int x, final int y, int button, boolean pressed) {
@@ -142,24 +140,23 @@ public class ItemDragHandler extends Gui {
 		
 		if(pressed) {
 			if(mod) {
-				cancelRelease.add(button);
-				container.clickInventory(x, y, button);
+                this.cancelRelease.add(button);
+                this.container.clickInventory(x, y, button);
 			}else {
 				mousePressed(x, y, slot, button);
 			}
 		}else {
-			if(cancelRelease.contains(button)) {
-				cancelRelease.remove(button);
+			if(this.cancelRelease.contains(button)) {
+                this.cancelRelease.remove(button);
 				return;
 			}
 			mouseReleased(x, y, slot, button);
 		}
-		
-		return;
-	}
+
+    }
 	
 	public void click(InventoryAction action, int[] args) {
-		mc.playerController.handleInventoryMouseClick(container.inventorySlots.containerId, action, args, mc.thePlayer);
+        this.mc.playerController.handleInventoryMouseClick(this.container.inventorySlots.containerId, action, args, this.mc.thePlayer);
 	}
 	
 	private void mousePressed(final int x, final int y, final Slot slot, int button) {
@@ -167,26 +164,22 @@ public class ItemDragHandler extends Gui {
 		
 		if(button == 0) {
 			long now = System.currentTimeMillis();
-			long sinceLast = now - lastClickTime;
-			if(lastClickSlot != null && lastClickSlot == slot && sinceLast < 250 && stack != null && !lastClickHoldingItem) {
-				doubleClick = true;
-			}else {
-				doubleClick = false;
-			}
-			
-			lastClickSlot = slot;
-			lastClickTime = now;
-			lastClickHoldingItem = stack != null;
+			long sinceLast = now - this.lastClickTime;
+            this.doubleClick = this.lastClickSlot != null && this.lastClickSlot == slot && sinceLast < 250 && stack != null && !this.lastClickHoldingItem;
+
+            this.lastClickSlot = slot;
+            this.lastClickTime = now;
+            this.lastClickHoldingItem = stack != null;
 		}
 		
 		if(stack == null) {
-			container.clickInventory(x, y, button);
-			cancelButtonRelease = button;
+            this.container.clickInventory(x, y, button);
+            this.cancelButtonRelease = button;
 		}else {
 			if(!isDragging()) {
-				draggingButton = button;
-				draggingItemStack = stack;
-				draggedSlots.clear();
+                this.draggingButton = button;
+                this.draggingItemStack = stack;
+                this.draggedSlots.clear();
 			}
 		}
 	}
@@ -198,9 +191,9 @@ public class ItemDragHandler extends Gui {
 			return;
 		}
 		
-		if(cancelButtonRelease != -1) {
-			int cancelButton = cancelButtonRelease;
-			cancelButtonRelease = -1;
+		if(this.cancelButtonRelease != -1) {
+			int cancelButton = this.cancelButtonRelease;
+            this.cancelButtonRelease = -1;
 			if(cancelButton == button) {
 				return;
 			}
@@ -208,59 +201,59 @@ public class ItemDragHandler extends Gui {
 		
 		boolean doClick = true;
 		
-		if(button == 0 && doubleClick && slot != null && slot.enableDragAndPickup()) {
+		if(button == 0 && this.doubleClick && slot != null && slot.enableDragAndPickup()) {
 			doClick = false;
 			pickupSimilarItems(slot);
-			doubleClick = false;
+            this.doubleClick = false;
 			stopDragging();
 		}
 		
 		if(isDragging()) {
-			if(button == draggingButton) {
-				if(draggedSlots.size() > 0) {
+			if(button == this.draggingButton) {
+				if(!this.draggedSlots.isEmpty()) {
 					spreadItemsAcrossDraggedSlots(x, y, button);
 					doClick = false;
 				}
 			}else {
-				cancelButtonRelease = draggingButton;
+                this.cancelButtonRelease = this.draggingButton;
 				doClick = false;
 			}
 			stopDragging();
 		}
 		
 		if(doClick) {
-			container.clickInventory(x, y, button);
+            this.container.clickInventory(x, y, button);
 		}
 	}
 	
 	private void stopDragging() {
-		draggingButton = -1;
-		draggingItemStack = null;
-		draggedSlots.clear();
+        this.draggingButton = -1;
+        this.draggingItemStack = null;
+        this.draggedSlots.clear();
 	}
 	
 	private void spreadItemsAcrossDraggedSlots(int x, int y, int mode) {
-		if(draggedSlots.size() < 1) {
+		if(this.draggedSlots.isEmpty()) {
 			return;
 		}
 		
-		if(draggedSlots.size() == 1) {
-			container.clickInventory(x, y, mode);
+		if(this.draggedSlots.size() == 1) {
+            this.container.clickInventory(x, y, mode);
 			return;
 		}
 		
 		InventoryAction action = mode == 1 ? InventoryAction.DRAG_ITEMS_ONE : InventoryAction.DRAG_ITEMS_ALL;
 		
-		if(mode == 2 && !mc.thePlayer.getGamemode().consumeBlocks()) {
+		if(mode == 2 && !this.mc.thePlayer.getGamemode().consumeBlocks()) {
 			action = InventoryAction.CREATIVE_DRAG;
 		}
 		
-		int[] slots = new int[draggedSlots.size()];
+		int[] slots = new int[this.draggedSlots.size()];
 		for(int i=0; i < slots.length; i++) {
-			slots[i] = draggedSlots.get(i).index;
+			slots[i] = this.draggedSlots.get(i).index;
 		}
-		
-		mc.playerController.handleInventoryMouseClick(container.inventorySlots.containerId, action, slots, mc.thePlayer);
+
+        this.mc.playerController.handleInventoryMouseClick(this.container.inventorySlots.containerId, action, slots, this.mc.thePlayer);
 		
 	}
 	
@@ -268,29 +261,29 @@ public class ItemDragHandler extends Gui {
 		if(!slot.enableDragAndPickup()) {
 			return;
 		}
-		
-		mc.playerController.handleInventoryMouseClick(container.inventorySlots.containerId, InventoryAction.PICKUP_SIMILAR, null, mc.thePlayer);
+
+        this.mc.playerController.handleInventoryMouseClick(this.container.inventorySlots.containerId, InventoryAction.PICKUP_SIMILAR, null, this.mc.thePlayer);
 	}
 	
 	public boolean isDragging() {
-		return draggingButton != -1;
+		return this.draggingButton != -1;
 	}
 	
 	private Slot getSlotAt(int x, int y) {
-		return container.getSlotAtPosition(x, y);
+		return this.container.getSlotAtPosition(x, y);
 	}
 	
 	private ItemStack getGrabbedItem() {
-		return mc.thePlayer.inventory.getHeldItemStack();
+		return this.mc.thePlayer.inventory.getHeldItemStack();
 	}
 	
 	public boolean isSlotDragged(Slot slot) {
-		return draggedSlots.size() > 1 && draggedSlots.contains(slot);
+		return this.draggedSlots.size() > 1 && this.draggedSlots.contains(slot);
 	}
 	
 	public ItemStack getHeldItemRenderOverride() {
-		if(isDragging() && draggedSlots.size() > 1) {
-			return renderItemStack;
+		if(isDragging() && this.draggedSlots.size() > 1) {
+			return this.renderItemStack;
 		}
 		return null;
 	}
